<template>
  <div class="view clusters">
    <nav class="nav">
      <div class="nav-item">
        <el-button type="primary" class="button" size="medium" @click="newCluster" :loading="clusterCreating">
          Create cluster
        </el-button>
      </div>
    </nav>

    <section class="section" v-loading="loading">
      <p class="label">Existing Clusters</p>

      <div v-if="clusters.length">
        <el-row>
          <el-col :span="24">
            <el-row :gutter="20">
              <el-col :xs="24" :sm="12" :md="8" v-for="cluster in clusters" :key="cluster.id">
                <div class="cluster-item" :class="'last_job' in cluster ? cluster.last_job.status : null">
                  <p class="name">
                    <router-link :to="{ name: 'clusters.view', params: { id: cluster.id } }">{{ cluster.name }}</router-link>
                  </p>
                  <p class="info">{{ 'last_job' in cluster ? cluster.last_job.playbook : '-' }}</p>
                  <p class="last-update" v-if="cluster.last_job">{{ cluster.last_job.started | moment('from', 'now') }}</p>
                  <p class="last-update" v-else>-</p>
                </div>
              </el-col>
            </el-row>
          </el-col>
        </el-row>
      </div>
      <el-row v-else-if="!loading">
        <el-col :span="4" :offset="7">
          <el-card class="empty">
            <p>You don’t have any clusters</p>
            <el-button type="primary" class="button" size="mini" @click="newCluster" :loading="clusterCreating">
              Create
            </el-button>
          </el-card>
        </el-col>
      </el-row>
    </section>
  </div>
</template>

<script>
export default {
  data () {
    return {
      clusters: [],
      loading: false,
      clusterCreating: false
    }
  },

  created () {
    this.$store.dispatch('breadcrumbs', [
      { label: 'Clusters', route: { name: 'clusters' } }
    ])

    this.fetch()
  },

  methods: {
    fetch () {
      this.loading = true
      this.$api.getClusters().then(response => {
        this.clusters = response.data
      }).finally(() => {
        this.loading = false
      })
    },

    newCluster () {
      this.$router.push({ name: 'clusters.new' })
    },

    createCluster () {
      this.clusterCreating = true
      this.$api.createCluster({
        name: `cluster-${this.$moment().format('MMDDYY-HHmmss')}`
      }).then(response => {
        return this.$api.generateNewSSHKeyByID(response.data.id).then(() => {
          this.$router.push({ name: 'clusters.view', params: { id: response.data.id }})
        })
      }).finally(() => {
        this.clusterCreating = false
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.empty {
  width: 462px;
  text-align: center;

  p {
    color: #606266;
    margin-bottom: 50px;
  }
}

.cluster-item {
  border: 1px solid #9b9b9b;
  border-top: 20px solid #9b9b9b;
  padding: 20px 20px;
  border-radius: 4px;
  margin-bottom: 20px;

  p {
    margin: 0;

    &:not(:last-child) {
      margin-bottom: 15px;
    }
  }

  .name {
    text-transform: uppercase;
    font-weight: 500;
    font-size: 18px;

    a {
      color: #606266;
    }
  }

  .info, .last-update {
    font-size: 16px;
  }

  &.succeeded {
    border-top-color: #318b04;
  }

  &.started {
    border-top-color: #d0021b;
  }
}
</style>
